#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

class_name EntityScript
func get_class() -> String: return "EntityScript"
static func get_instance_base_type() -> StringName: return "EntityScript"

var _host: ScriptMachine
func _init(host: Node) -> void: _host = host
func _dispose() -> void:
	_host.dispose_entity(self)

func _on_create() -> void: pass
func _on_update(delta: float) -> void: pass
func _on_update_cycle(delta: float) -> void: pass
func _on_destroy() -> void: pass

func hook_cycles()   -> void: _host.update_cycle.connect(_on_update_cycle)
func unhook_cycles() -> void: _host.update_cycle.disconnect(_on_update_cycle)

func get_agent(agent: String) -> AgentScript:
	return _host.get_agent(agent)

func get_utility(utility: String) -> RefCounted:
	return _host.get_utility(utility)
